<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>ExpressionCalculator.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Calculator</a> &gt; <a href="index.source.html" class="el_package">service</a> &gt; <span class="el_source">ExpressionCalculator.java</span></div><h1>ExpressionCalculator.java</h1><pre class="source lang-java linenums">package service;

/**
 *  this class checks for patterns in a string and modifies the equation stack based on pattern matches
 */
<span class="nc" id="L6">public class ExpressionCalculator {</span>

    /**
     * @param s a string which represents an expression such as sqrt(46.245)
     * @return the string value of the square root operation applied on the sqrt parameter
     */
    private static String exprIsSqrt(String s) {
<span class="fc" id="L13">        String[] sqrt = s.split(&quot;sqrt\\(|\\)&quot;);</span>
<span class="fc" id="L14">        double x = Double.parseDouble(sqrt[1]);</span>
<span class="fc" id="L15">        x = Math.sqrt(x);</span>
<span class="fc" id="L16">        return String.valueOf(x);</span>
    }

    /**
     * @param s a string which represents an expression such as max(1,2)
     * @return the string value of the greater parameter of the max function
     */
    private static String exprIsMax(String s) {
<span class="fc" id="L24">        String[] max = s.split(&quot;max\\(|\\)|,&quot;);</span>
<span class="fc" id="L25">        double x = Math.max(Double.parseDouble(max[1]),Double.parseDouble(max[2]));</span>
<span class="fc" id="L26">        return String.valueOf(x);</span>
    }

    /**
     * @param s a string which represents an expression such as min(1,2)
     * @return the string value of the lesser parameter of the min function
     */
    private static String exprIsMin(String s) {
<span class="fc" id="L34">        String[] min = s.split(&quot;min\\(|\\)|,&quot;);</span>
<span class="fc" id="L35">        double x = Math.min(Double.parseDouble(min[1]),Double.parseDouble(min[2]));</span>
<span class="fc" id="L36">        return String.valueOf(x);</span>
    }

    /**
     * @param s a string representing a token extracted from the original equation
     * @return the string result of the operation or the number itself
     * @throws Exception if the pattern of the token is not one of the 4 known patterns:
     * number, sqrt(number), min(number, number), max(number, number)
     */
    public static String parseOperand(String s) throws Exception {
<span class="fc" id="L46">        final String DOUBLE = &quot;(0|[1-9][0-9]*)(\\.[0-9]+)?&quot;;</span>
<span class="fc bfc" id="L47" title="All 2 branches covered.">        if (s.matches(&quot;sqrt\\(&quot;+DOUBLE+&quot;\\)&quot;)) {</span>
<span class="fc" id="L48">            return exprIsSqrt(s);</span>
        }
<span class="fc bfc" id="L50" title="All 2 branches covered.">        else if (s.matches(&quot;max\\(&quot; + DOUBLE +&quot;,&quot; + DOUBLE +&quot;\\)&quot;)) {</span>
<span class="fc" id="L51">            return exprIsMax(s);</span>
        }
<span class="fc bfc" id="L53" title="All 2 branches covered.">        else if (s.matches(&quot;min\\(&quot; + DOUBLE +&quot;,&quot; + DOUBLE +&quot;\\)&quot;)) {</span>
<span class="fc" id="L54">            return exprIsMin(s);</span>
        }
<span class="fc bfc" id="L56" title="All 2 branches covered.">        else if (s.matches(DOUBLE)) {</span>
<span class="fc" id="L57">            return s;</span>
        }
        else {
<span class="fc" id="L60">            throw new Exception(&quot;UNKNOWN PATTERN: &quot; + s);</span>
        }
    }

    /**
     * @param s an operator as a string ( +, -, /, *)
     * @param first the first term of the operation
     * @param second the second term of the operation
     * @return the string value of the result of the operation
     * @throws Exception if the operator is not one of the 4 known operators
     */
    public static String calculateExpression(String s, String first, String second) throws Exception {
<span class="fc" id="L72">        double first_term = Double.parseDouble(first);</span>
<span class="fc" id="L73">        double second_term = Double.parseDouble(second);</span>
<span class="fc bfc" id="L74" title="All 5 branches covered.">        switch (s) {</span>
<span class="fc" id="L75">            case &quot;+&quot; -&gt; { return String.valueOf(first_term + second_term); }</span>
<span class="fc" id="L76">            case &quot;-&quot; -&gt; { return String.valueOf(first_term - second_term); }</span>
<span class="fc" id="L77">            case &quot;*&quot; -&gt; { return String.valueOf(first_term * second_term); }</span>
            case &quot;/&quot; -&gt; {
<span class="fc bfc" id="L79" title="All 2 branches covered.">                if (second_term==0) throw new Exception(&quot;DIVISION BY ZERO&quot;);</span>
<span class="fc" id="L80">                return String.valueOf(first_term / second_term);</span>
            }
<span class="fc" id="L82">            default -&gt; throw new Exception(&quot;UNKNOWN OPERATOR&quot;);</span>
        }
    }
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.8.202204050719</span></div></body></html>